=== requirements.txt ===
defusedxml
packaging
psutil>=5.6.7
windows-curses; platform_system == 'Windows'
