=== debian/changelog ===
glances (4.3.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    + Bump to Standards-Version 4.7.2 (no changes needed)
  * debian/patches
    + Refresh 008_fix_lintian_warnings_in_manpage.diff patch

 -- Daniel Echeverri <epsilon@debian.org>  Fri, 28 Mar 2025 19:17:28 -0500
