=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
 	       python3-sphinx-rtd-theme,
                python3-ujson,
                python3-orjson,
-               pybuild-plugin-pyproject
+               pybuild-plugin-pyproject,
+               bash-completion
 Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/glances
 Vcs-Git: https://salsa.debian.org/debian/glances.git
