## glances 4.3.3+dfsg

=== Makefile ===
--- 
+++ 
@@ -114,6 +114,23 @@
 test-min-with-upgrade: venv-min-upgrade ## Upgrade deps and run unit tests in minimal environment
 	$(venv_min)/python -m pytest tests/test_core.py
 
+test-export-csv: ## Run interface tests with CSV
+	/bin/bash ./tests/test_export_csv.sh
+
+test-export-json: ## Run interface tests with JSON
+	/bin/bash ./tests/test_export_json.sh
+
+test-export-influxdb-v1: ## Run interface tests with InfluxDB version 1 (Legacy)
+	/bin/bash ./tests/test_export_influxdb_v1.sh
+
+test-export-influxdb-v3: ## Run interface tests with InfluxDB version 3 (Core)
+	/bin/bash ./tests/test_export_influxdb_v3.sh
+
+test-export-timescaledb: ## Run interface tests with TimescaleDB
+	/bin/bash ./tests/test_export_timescaledb.sh
+
+test-export: test-export-csv test-export-json test-export-influxdb-v1 test-export-influxdb-v3 test-export-timescaledb## Tests all exports
+
 # ===================================================================
 # Linters, profilers and cyber security
 # ===================================================================
@@ -123,6 +140,9 @@
 
 lint: ## Lint the code.
 	$(venv_full)/python -m ruff check . --fix
+
+lint-readme: ## Lint the main README.rst file
+	$(venv_full)/python -m rstcheck README.rst
 
 codespell: ## Run codespell to fix common misspellings in text files
 	$(venv_full)/codespell -S .git,./docs/_build,./Glances.egg-info,./venv*,./glances/outputs,*.svg -L hart,bu,te,statics -w
@@ -188,6 +208,7 @@
 # ===================================================================
 
 docs: ## Create the documentation
+	$(PYTHON) ./generate_openapi.py
 	$(PYTHON) -m glances -C $(CONF) --api-doc > ./docs/api.rst
 	cd docs && ./build.sh && cd ..
 
@@ -219,6 +240,9 @@
 
 webui-audit-fix: ## Fix audit the Web UI
 	cd $(DIR) && npm audit fix && npm ci && npm run build
+
+webui-update: ## Update JS dependencies
+	cd $(DIR) && npm update --save && npm ci && npm run build
 
 # ===================================================================
 # Packaging
@@ -283,19 +307,3 @@
 	$(venv_min)/python -m glances -C $(CONF) -d
 
 run-min-local-conf: ## Start minimal Glances in console mode with the system conf file
-	$(venv_min)/python -m glances
-
-run-like-htop: ## Start Glances with the same features than Htop
-	$(venv_min)/python -m glances --disable-plugin network,ports,wifi,connections,diskio,fs,irq,folders,raid,smart,sensors,vms,containers,ip,amps --disable-left-sidebar
-
-$(DOCKER_RUNTIMES): run-docker-%:
-	$(DOCKER_RUN) $(DOCKER_OPTS) $(DOCKER_SOCKS) -it glances:local-$*
-
-run-docker-alpine-minimal: ## Start Glances Alpine Docker minimal in console mode
-run-docker-alpine-full: ## Start Glances Alpine Docker full in console mode
-run-docker-alpine-dev: ## Start Glances Alpine Docker dev in console mode
-run-docker-ubuntu-minimal: ## Start Glances Ubuntu Docker minimal in console mode
-run-docker-ubuntu-full: ## Start Glances Ubuntu Docker full in console mode
-run-docker-ubuntu-dev: ## Start Glances Ubuntu Docker dev in console mode
-
-run-webserver: ## Start Glances in Web server mode
