=== requirements.txt ===
defusedxml
packaging
psutil>=5.6.7
shtab; platform_system != 'Windows'
windows-curses; platform_system == 'Windows'
