=== debian/changelog ===
glances (4.3.3+dfsg-1) unstable; urgency=medium

  * New upstream version 4.3.3+dfsg
  * debian/control
    + Add bash-completion in B-D
  * debian/glances.postinst
    + Add function to generate bash completion
  * debian/glances.postrm
    + Remove bash completion file in purge process
  * debian/patches
    + Refresh 004_disable-pypi.patch
    + Refresh 006_indicate_user_webserver_static_files_not_included.patch
    + Refresh 008_fix_lintian_warnings_in_manpage.diff patch
  * debian/source/lintian-overrides
    + Add new lintian overrides

 -- Daniel Echeverri <epsilon@debian.org>  Sat, 30 Aug 2025 20:17:27 -0500
