=== debian/tests/control ===
Tests: install
Depends: @, curl
Restrictions: needs-root,allow-stderr
