=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,\
  repack,compression=gz,\
  dversionmangle=s/\+dfsg\d*$//,oversionmangle=s/$/+dfsg/,\
  uversionmangle=s/_/./;s/RC/~rc/,filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/glances-$1\.tar\.gz/ \
  https://github.com/nicolargo/glances/tags .*/v?(\d\S+)\.tar\.gz
